new;
library tools;

output file = tools2.out reset;

/*
**
** Golub, G.H. and C.F. Van Loan [1989], Matrix Computations,
** second edition, Johns Hopkins University Press, section 4.7.3
**
** Example 4.7.2
**
**     let r = 1 .5 .2;
**     let b = 4 -1 3;
**     x = Toeplitz_Solve(r,b);
**
*/

let r = 1 .5 .2;
let b = 4 -1 3;
x = Toeplitz_Solve(r,b);
sol = (355|-376|285)/56;

print "The solution is";
print sol';
print "Toeplitz_Solve(r,b) = ";
print x'; print;

N = 10;
r = rndu(N,1);
b = rndu(N,1);
x = Toeplitz_Solve(r,b);
Rmatrix = toeplitz(r);
x2 = b/Rmatrix;
print "        1st sol.        2nd sol.";
print x~x2;
print;


N = 300;

r = rndu(N,1);
b = rndu(N,1);

time_start;
x = Toeplitz_Solve(r,b);
print ftos(time_end,"Computational time: %lf seconds",1,5);

Rmatrix = toeplitz(r);

time_start;
x2 = b/Rmatrix;
print ftos(time_end,"Computational time: %lf seconds",1,5);

output off;
